-- Main trigger
trigger = ScriptTrigger()                     -- Create the trigger
trigger:setScript("cutscene.lua")             -- Tell the trigger which script to call
trigger:setFunction("tick")                   -- Tell the trigger which scriptfunction to call
trigger:setActiveOnCreation(true)      

-- Cameraswitchone
triggerOne = ScriptTrigger()
triggerOne:setScript("cutscene.lua")
triggerOne:setFunction("switchCamTargetToEarth")
triggerOne:setAbsCoor(0 , 0 , 0)
triggerOne:setTarget("CameraOne")
triggerOne:setRadius(10)
triggerOne:setDebugDraw(true)


-- Cameraswitchtwo
triggerTwo = ScriptTrigger()
triggerTwo:setScript("cutscene.lua")
triggerTwo:setFunction("switchCamToSpaceship")
triggerTwo:setAbsCoor(0, 0 , 150)
triggerTwo:setTarget("CameraOne")
triggerTwo:setRadius(5)
triggerTwo:setDebugDraw(true)  

-- Cameraswitchthree
triggerThree = ScriptTrigger()
triggerThree:setScript("cutscene.lua")
triggerThree:setFunction("switchCamToStation")
triggerThree:setAbsCoor(-125, 0 , 175)
triggerThree:setTarget("CameraOne")
triggerThree:setRadius(5)
triggerThree:setDebugDraw(true)  

 
-- Get objects from orxonox
thisscript:addObject("CameraMan", "cameraManager")
thisscript:addObject("NPC", "shutleOne")
thisscript:addObject("NPC", "fighterOne")
thisscript:addObject("NPC", "fighterTwo")
thisscript:addObject("NPC", "bomberOne")
thisscript:addObject("NPC", "bomberTwo")
thisscript:addObjectAsName("GameWorld", "Cut Scene", "gameWorld")


-- Global Variables
time = 0
stationReached = false
fadeout = false
bInit = 0
bInit2 = 0
fighterSpeed = 10
bomberSpeed = 10

-- Since the spaceships go along the x direction we only neet to get these once:
fighterOneY = fighterOne:getAbsCoorY()
fighterOneZ = fighterOne:getAbsCoorZ()

fighterTwoY = fighterTwo:getAbsCoorY()
fighterTwoZ = fighterTwo:getAbsCoorZ()
  
bomberOneY = bomberOne:getAbsCoorY()
bomberOneZ = bomberOne:getAbsCoorZ()

bomberTwoY = bomberTwo:getAbsCoorY()
bomberTwoZ = bomberTwo:getAbsCoorZ()


-- shutleOne
shutle = { }
--{

 function shutle:tick(timestep)

 if cameraManager:getCurrCameraCoorZ() > 0 then
  coorX = shutleOne:getAbsCoorX()
  coorY = shutleOne:getAbsCoorY()
  coorZ = shutleOne:getAbsCoorZ()
  shutleOne:setAbsCoor(coorX-6.5*timestep,coorY,coorZ)
 end
 end

 --}


-- chaseScene
chaseScene = { }
--{

 function chaseScene:tick(timestep)


  fighterOneX = fighterOne:getAbsCoorX()
  fighterTwoX = fighterTwo:getAbsCoorX()
  bomberOneX  = bomberOne:getAbsCoorX()
  bomberTwoX  = bomberTwo:getAbsCoorX()
  
  fighterOne:setAbsCoor(fighterOneX + fighterSpeed*timestep,fighterOneY,fighterOneZ)
  fighterTwo:setAbsCoor(fighterTwoX + fighterSpeed*timestep,fighterTwoY,fighterTwoZ)
  bomberOne:setAbsCoor(bomberOneX + bomberSpeed*timestep,bomberOneY,bomberOneZ)
  bomberTwo:setAbsCoor(bomberTwoX + bomberSpeed*timestep,bomberTwoY,bomberTwoZ)
  
 
 end

 --}



-- Switch cam functions
function switchCamTargetToEarth(timestep)
cameraManager:changeCurrTarget("Planet", "Earth")
return true
end

function switchCamToSpaceship(timestep)
cameraManager:atachCurrCameraToWorldEntity( "NPC", "shutleOne")
return true
end

function switchCamToStation(timestep)
cameraManager:atachCurrCameraToWorldEntity("Building", "zhara")
stationReached = true
time = 0
--cameraManager:detachCurrCamera()
return true
end


-- THE tick function

function tick(timestep)
time = time + timestep

shutle:tick(timestep)
chaseScene:tick(timestep)

if bInit == 0 then
  cameraManager:initFadeBlack()
  gameWorld:showText("Earth Solar System");
  bInit = 1
end

if time > 2 and bInit2 == 0 then
   cameraManager:toggleFade()
   bInit2 = 1
end

if not cameraSwitched then
cameraManager:setCam("CameraOne")
--cameraManager:atachCurrCameraToWorldEntity("NPC", "fighterOne")
cameraManager:changeCurrTarget("Building", "zhara")
cameraSwitched = true
end

if time > 4  and stationReached and not fadeout then
cameraManager:toggleFade()
fadeout = true
end

if time > 6 and stationReached then
gameWorld:setNextStoryName( "Space Station 1" ) 
gameWorld:stop()
return true
end

return false
end 
